/**
 * apaleo Migration API - not safe for work
 * Continuously evolving version - use at your own risk! Import transactional data from other PMS.
 *
 * OpenAPI spec version: v0-nsfw
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */
import { Inject, Injectable, Optional } from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams } from '@angular/common/http';
import { CustomHttpUrlEncodingCodec } from '../encoder';
import { BASE_PATH } from '../variables';
import { Configuration } from '../configuration';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common/http";
import * as i2 from "../configuration";
function append(formParams, param, value) {
    if (formParams instanceof FormData) {
        formParams.append(param, value);
        return formParams;
    }
    else if (formParams instanceof HttpParams) {
        return formParams.append(param, value);
    }
    formParams.append(param, value);
    return formParams;
}
;
var MigrationService = /** @class */ (function () {
    function MigrationService(httpClient, basePath, configuration) {
        this.httpClient = httpClient;
        this.basePath = 'https://localhost';
        this.defaultHeaders = new HttpHeaders();
        this.configuration = new Configuration();
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    MigrationService.prototype.canConsumeForm = function (consumes) {
        var form = 'multipart/form-data';
        for (var _i = 0, consumes_1 = consumes; _i < consumes_1.length; _i++) {
            var consume = consumes_1[_i];
            if (form === consume) {
                return true;
            }
        }
        return false;
    };
    MigrationService.prototype.migrationBatchByIdGet = function ($params, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        var id = $params.id;
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling migrationBatchByIdGet.');
        }
        var apaleoCurrentDateTime = $params.apaleoCurrentDateTime;
        var headers = this.defaultHeaders;
        if (apaleoCurrentDateTime !== undefined && apaleoCurrentDateTime !== null) {
            headers = headers.set('Apaleo-Current-DateTime', String(apaleoCurrentDateTime));
        }
        // authentication (oauth2) required
        if (this.configuration.accessToken) {
            var accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        var httpHeaderAccepts = [
            'text/plain',
            'application/json',
            'text/json'
        ];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }
        // to determine the Content-Type header
        var consumes = [];
        return this.httpClient.get(this.basePath + "/migration/v0-nsfw/batch/" + encodeURIComponent(String(id)), {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    MigrationService.prototype.migrationReservationsUploadPost = function ($params, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        var formFile = $params.formFile;
        if (formFile === null || formFile === undefined) {
            throw new Error('Required parameter formFile was null or undefined when calling migrationReservationsUploadPost.');
        }
        var apaleoCurrentDateTime = $params.apaleoCurrentDateTime;
        var idempotencyKey = $params.idempotencyKey;
        var headers = this.defaultHeaders;
        if (apaleoCurrentDateTime !== undefined && apaleoCurrentDateTime !== null) {
            headers = headers.set('Apaleo-Current-DateTime', String(apaleoCurrentDateTime));
        }
        if (idempotencyKey !== undefined && idempotencyKey !== null) {
            headers = headers.set('Idempotency-Key', String(idempotencyKey));
        }
        // authentication (oauth2) required
        if (this.configuration.accessToken) {
            var accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        var httpHeaderAccepts = [
            'text/plain',
            'application/json',
            'text/json'
        ];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }
        // to determine the Content-Type header
        var consumes = [
            'multipart/form-data'
        ];
        var canConsumeForm = this.canConsumeForm(consumes);
        var formParams;
        var useForm = false;
        var convertFormParamsToString = false;
        // use FormData to transmit files using content-type "multipart/form-data"
        // see https://stackoverflow.com/questions/4007969/application-x-www-form-urlencoded-or-multipart-form-data
        useForm = canConsumeForm;
        if (useForm) {
            formParams = new FormData();
        }
        else {
            formParams = new HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
        }
        if (formFile !== undefined) {
            formParams = append(formParams, 'formFile', formFile);
        }
        return this.httpClient.post(this.basePath + "/migration/v0-nsfw/reservations-upload", convertFormParamsToString ? formParams.toString() : formParams, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    MigrationService.prototype.migrationTriggerBatchPost = function ($params, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        var model = $params.model;
        if (model === null || model === undefined) {
            throw new Error('Required parameter model was null or undefined when calling migrationTriggerBatchPost.');
        }
        var apaleoCurrentDateTime = $params.apaleoCurrentDateTime;
        var idempotencyKey = $params.idempotencyKey;
        var headers = this.defaultHeaders;
        if (apaleoCurrentDateTime !== undefined && apaleoCurrentDateTime !== null) {
            headers = headers.set('Apaleo-Current-DateTime', String(apaleoCurrentDateTime));
        }
        if (idempotencyKey !== undefined && idempotencyKey !== null) {
            headers = headers.set('Idempotency-Key', String(idempotencyKey));
        }
        // authentication (oauth2) required
        if (this.configuration.accessToken) {
            var accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        var httpHeaderAccepts = [
            'text/plain',
            'application/json',
            'text/json'
        ];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }
        // to determine the Content-Type header
        var consumes = [
            'application/json-patch+json',
            'application/json',
            'text/json',
            'application/_*+json'
        ];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }
        return this.httpClient.post(this.basePath + "/migration/v0-nsfw/trigger-batch", model, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    MigrationService.ɵfac = function MigrationService_Factory(t) { return new (t || MigrationService)(i0.ɵɵinject(i1.HttpClient), i0.ɵɵinject(BASE_PATH, 8), i0.ɵɵinject(i2.Configuration, 8)); };
    MigrationService.ɵprov = i0.ɵɵdefineInjectable({ token: MigrationService, factory: MigrationService.ɵfac });
    return MigrationService;
}());
export { MigrationService };
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(MigrationService, [{
        type: Injectable
    }], function () { return [{ type: i1.HttpClient }, { type: undefined, decorators: [{
                type: Optional
            }, {
                type: Inject,
                args: [BASE_PATH]
            }] }, { type: i2.Configuration, decorators: [{
                type: Optional
            }] }]; }, null); })();
//# sourceMappingURL=migration.service.js.map